Unit ASK5C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AR01C_p, AR02C_p, ASTAC_p;

procedure ASK5C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer);

implementation

procedure ASK5C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer);
var
M2,I,J :Integer;
PII,RL :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2;
begin

{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C KETOHO-PKYHTHO MATPE , BCE KETK KOTOPO CYT    C }
{       TEEB MATP (T.E. A - BYXYPOBHEBA MATPA CT - TA)  C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHE CCTEM )  ,       C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       MATPA  A  KETOHOO PAMEPA  L * L , C KETKAM PAMEPA    C }
{       M * M , OOHM PEOPAOBAHEM PBOTC K KETOHO-       C }
{       AOHAHO MATPE TEX E PAMEPOB . TEM CAMM PEEHE      C }
{       CXOHO CCTEM OPKA M * L  CBEEHO K PEEH   L         C }
{       CCTEM OPKA  M , MATP KOTOPX - TEEB .             C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASK5C(A,X,R,M,L)                                         C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  M * L , B KOTOPOM    C }
{           AAETC MATPA CCTEM COACHO PABAM , AHHM B     C }
{           ( 1 ) . A MEHHO : MACCB  A  ETC HA  L  KYCKOB       C }
{           H  2 * M - 1 . B  I - OM KYCKE  AAETC  I -A       C }
{           KETKA EPBO KETOHO CTPOK CXOHO MATP . P     C }
{           AAH  I -O KETK B  I -OM KYCKE ACBAETC         C }
{           CHAAA EPBA CTPOKA TO KETK , BCE A KOTOPO      C }
{           ACBATC EMEHT EPBOO CTOA HAHA CO BTOPOO. C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M * L , B KOTOPOM    C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H MAX(2M,L).    C }
{                                                                     C }
{       M - OPOK 2 - O YPOBH . T : E.                      C }
{                                                                     C }
{       L - OPOK 1 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{                                                                     C }
{       AR01C , AR02C , ASTAC                                         C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{  -------------------------  KOHCTAHT  ---------------------------- C }

{       SYS003=6.2831853717958647692528 ( 2 *  ) }



PII := SYS003/L;
M2 := 2*M-1;

AR01C(A,R,M2,L,PII);
AR02C(X,R,M,L,PII);

J := 1;
for I:=1 to L do
 begin
  ASTAC(A[J-1],X[0+(I-1)*M],R,M);
_1:
  J := J+M2;
 end;

AR01C(X,R,M,L,PII);
RL := 1.0/L;
for J:=1 to L do
 begin
  for I:=1 to M do
   begin
_2:
    X[(I-1)+(J-1)*M] := MulC(X[(I-1)+(J-1)*M],Cmplx(RL,0.0));
   end;
 end;
end;

end.
